apps/registration/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.urls import path

from .views import MyAccountDetailView, ResetAdminView, SignupView, UserDetailView, UserImpersonateView, \
    UserListView, UserResendValidationEmailView, UserUpdateView, UserUploadPhotoAuthorizationView, UserValidateView, \
    UserValidationEmailSentView

app_name = "registration"

urlpatterns = [
    path("signup/", SignupView.as_view(), name="signup"),
    path('validate_email/sent/', UserValidationEmailSentView.as_view(), name='email_validation_sent'),
    path('validate_email/resend/<int:pk>/', UserResendValidationEmailView.as_view(),
         name='email_validation_resend'),
    path('validate_email/<uidb64>/<token>/', UserValidateView.as_view(), name='email_validation'),
    path("user/", MyAccountDetailView.as_view(), name="my_account_detail"),
    path("user/<int:pk>/", UserDetailView.as_view(), name="user_detail"),
    path("user/<int:pk>/update/", UserUpdateView.as_view(), name="update_user"),
    path("user/<int:pk>/upload-photo-authorization/", UserUploadPhotoAuthorizationView.as_view(),
         name="upload_user_photo_authorization"),
    path("user/<int:pk>/impersonate/", UserImpersonateView.as_view(), name="user_impersonate"),
    path("user/list/", UserListView.as_view(), name="user_list"),
    path("reset-admin/", ResetAdminView.as_view(), name="reset_admin"),
]

corres2math/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

"""corres2math URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.0/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.contrib import admin
from django.urls import include, path
from django.views.defaults import bad_request, page_not_found, permission_denied, server_error
from django.views.generic import TemplateView
from registration.views import PhotoAuthorizationView

from .views import AdminSearchView

urlpatterns = [
    path('', TemplateView.as_view(template_name="index.html"), name='index'),
    path('about/', TemplateView.as_view(template_name="about.html"), name='about'),
    path('i18n/', include('django.conf.urls.i18n')),
    path('admin/doc/', include('django.contrib.admindocs.urls')),
    path('admin/', admin.site.urls, name="admin"),
    path('accounts/', include('django.contrib.auth.urls')),
    path('search/', AdminSearchView.as_view(), name="haystack_search"),

    path('api/', include('api.urls')),
    path('participation/', include('participation.urls')),
    path('registration/', include('registration.urls')),

    path('media/authorization/photo/<str:filename>/', PhotoAuthorizationView.as_view(), name='photo_authorization'),

    path('', include('eastereggs.urls')),
]

if 'cas_server' in settings.INSTALLED_APPS:  # pragma: no cover
    urlpatterns += [
        path('cas/', include('cas_server.urls', namespace="cas_server")),
    ]

handler400 = bad_request
handler403 = permission_denied
handler404 = page_not_found
handler500 = server_error

corres2math/views.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.exceptions import PermissionDenied
from haystack.generic_views import SearchView


class AdminMixin(LoginRequiredMixin):
    def dispatch(self, request, *args, **kwargs):
        if not request.user.is_authenticated:
            return self.handle_no_permission()
        if not request.user.registration.is_admin:
            raise PermissionDenied
        return super().dispatch(request, *args, **kwargs)


class AdminSearchView(AdminMixin, SearchView):
    pass

corres2math/templates/about.html
{% extends "base.html" %}

{% block contenttitle %}
    <h1>À propos</h1>
{% endblock %}

{% block content %}
    <p>
    La plateforme d'inscription des Correspondances des Jeunes Mathématiciennes a été développée entre 2019 et 2021
    par Yohann D'ANELLO, bénévole pour l'association Animath. Elle est vouée à être utilisée par les participants
    pour intéragir avec les organisateurs et les autres participants.
    </p>

    <p>
    La plateforme est développée avec le framework <a href="https://www.djangoproject.com/">Django</a> et le code
    source est accessible librement sur <a href="https://gitlab.com/animath/si/plateforme-corres2math">Gitlab</a>.
    Le code est distribué sous la licence <a href="https://www.gnu.org/licenses/gpl-3.0.html">GNU GPL v3</a>,
    qui vous autorise à consulter le code, à le partager, à réutiliser des parties du code et à contribuer.
    </p>

    <p>
    Le site principal présent sur <a href="https://inscription.correspondances-maths.fr/">https://inscription.correspondances-maths.fr</a>
    est hébergé chez <a href="https://www.scaleway.com/fr/">Scaleway</a>.
    </p>

    <p>
    Les données collectées par cette plateforme sont utilisées uniquement dans le cadre des Correspondances et sont
    détruites dès l'action touche à sa fin, soit au plus tard 1 an après le début de l'action. Sur autorisation
    explicite, des informations de contact peuvent être conservées afin d'être tenu au courant des actions futures
    de l'association Animath. Aucune information personnelle n'est collectée à votre insu. Aucune information
    personnelle n'est cédée à des tiers.
    </p>

    <p>
    Pour toute demande ou réclammation, merci de nous contacter à l'adresse
    <a target="_blank" href="mailto:&#99;&#111;&#110;&#116;&#97;&#99;&#116;&#64;&#99;&#111;&#114;&#114;&#101;&#115;&#112;&#111;&#110;&#100;&#97;&#110;&#99;&#101;&#115;&#45;&#109;&#97;&#116;&#104;&#115;&#46;&#102;&#114;">
        &#99;&#111;&#110;&#116;&#97;&#99;&#116;&#64;&#99;&#111;&#114;&#114;&#101;&#115;&#112;&#111;&#110;&#100;&#97;&#110;&#99;&#101;&#115;&#45;&#109;&#97;&#116;&#104;&#115;&#46;&#102;&#114;
    </a>.
    </p>
{% endblock %}

corres2math/templates/amount_input.html
<div class="input-group">
    <input class="form-control mx-auto d-block" type="number" min="0" step="0.01"
           {% if widget.value != None and widget.value != "" %}value="{{ widget.value }}"{% endif %}
           name="{{ widget.name }}"
            {% for name, value in widget.attrs.items %}
                {% ifnotequal value False %}{{ name }}{% ifnotequal value True %}="{{ value|stringformat:'s' }}"{% endifnotequal %}{% endifnotequal %}
            {% endfor %}>
    <div class="input-group-append">
        <span class="input-group-text">€</span>
    </div>
</div>

corres2math/templates/autocomplete_model.html
<input type="hidden" name="{{ widget.name }}" {% if widget.attrs.model_pk %}value="{{ widget.attrs.model_pk }}"{% endif %} id="{{ widget.attrs.id }}_pk">
<input type="text"
   {% if widget.value != None and widget.value != "" %}value="{{ widget.value }}"{% endif %}
   name="{{ widget.name }}_name" autocomplete="off"
    {% for name, value in widget.attrs.items %}
        {% ifnotequal value False %}{{ name }}{% ifnotequal value True %}="{{ value|stringformat:'s' }}"{% endifnotequal %}{% endifnotequal %}
    {% endfor %}>
<ul class="list-group list-group-flush" id="{{ widget.attrs.id }}_list">
</ul>

corres2math/templates/base_modal.html
{% load i18n %}

<div id="{{ modal_id }}Modal" class="modal fade" tabindex="-1" role="dialog">
    <div class="modal-dialog {{ modal_additional_class }}" role="document">
        <form id="{{ modal_id }}-form" method="{{ modal_form_method|default:"post" }}" action="{{ modal_action }}" enctype="{{ modal_enctype|default:"application/x-www-form-urlencoded" }}">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">{{ modal_title }}</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">{{ modal_content }}</div>
                <div class="modal-footer">
                    {{ extra_modal_button }}
                    {% if modal_button %}
                        <button type="submit" class="btn btn-{{ modal_button_type|default:"primary" }}">{{ modal_button }}</button>
                    {% endif %}
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">{% trans "Close" %}</button>
                </div>
            </div>
        </form>
    </div>
</div>

corres2math/templates/index.html
{% extends "base.html" %}

{% block content %}
    <div>

    <div class="jumbotron bg-white">
        <div class="row">
            <h1 class="display-3">
                Bienvenue sur le site d'inscription aux <a href="https://correspondances-maths.fr/" target="_blank">
                    Correspondances des Jeunes Mathématicien·ne·s</a> !
            </h1>
        </div>
    </div>
    <div class="row jumbotron bg-white">
        <div class="col-sm">
            <h3>
                Tu souhaites participer aux Correspondances ?
                <br/>
                Ton équipe est déjà formée ?
            </h3>
        </div>
        <div class="col-sm text-right">
            <div class="btn-group-vertical">
                <a class="btn btn-primary btn-lg" href="{% url "registration:signup" %}" role="button">Inscris-toi maintenant !</a>
                <a class="btn btn-light btn-lg" href="{% url "login" %}" role="button">J'ai déjà un compte</a>
            </div>
        </div>
    </div>

        <div class="alert alert-danger">
            Avertissement : certains rencontrent des difficultés à recevoir les mails automatiques. Merci de vérifier
            régulièrement votre boîte spam, et à nous contacter en cas de problème.
        </div>

    <div class="jumbotron">
        <h5 class="display-4">Comment ça marche ?</h5>
        <p>
            Pour participer aux Correspondances, il suffit de créer un compte sur la rubrique <strong><a href="{% url "registration:signup" %}">Inscription</a></strong>.
            Vous devrez ensuite confirmer votre adresse e-mail.
        </p>

        <p class="text-justify">
            Vous pouvez accéder à votre compte via la rubrique <strong><a href="{% url "login" %}">Connexion</a></strong>.
            Une fois connecté, vous pourrez créer une équipe ou en rejoindre une déjà créée par l'un de vos camarades
            via un code d'accès qui vous aura été transmis. Vous serez ensuite invité à soumettre une autorisation de droit à l'image,
            indispensable au bon déroulement des Correspondances. Une fois que votre équipe comporte au moins 3 participants (maximum 5)
            et un encadrant, vous pourrez demander à valider votre équipe pour être apte à travailler sur le problème de votre choix.
        </p>

        <h2>Je ne trouve pas d'équipe, aidez-moi !</h2>

        <p class="text-justify">
            En ayant créé un compte sur cette plateforme, vous créez également un compte sur la plateforme de chat dédiée
            aux Correspondances, basée sur le protocole <a href="https://matrix.org/">Matrix</a> et le client
            <a href="https://element.io">Element</a>. Cette interface de chat vous permet de communiquer avec les membres
            de votre équipe, mais surtout de pouvoir échanger durant la troisième phase des Correspondances, et
            également de poser vos questions en cas de besoin.
        </p>

        <p class="text-justify">
            Ce chat contient également un salon <code>#je-cherche-une-equipe</code> où vous pouvez crier à l'aide pour trouver
            une équipe, ou compléter la votre s'il vous manque des participants. C'est un petit coin auprès du feu, un parc à
            jeu où vous pouvez descendre en toboggan (en le désinfectant après utilisation), ne cherchez pas à être trop formel.
        </p>

        <h2>J'ai une question</h2>

        <p class="text-justify">
            Pour toute question, vous pouvez soit la poser dans <code>#faq</code> dans l'onglet chat comme indiqué ci-dessus, soit nous
            contacter par mail à l'adresse <a href="mailto:contact@correspondances-maths.fr">contact@correspondances-maths.fr</a>.
        </p>

        <div class="alert alert-warning">
            <strong>Attention aux dates !</strong> Si vous ne finalisez pas votre inscription dans le délai indiqué, vous
            ne pourrez malheureusement pas participer aux Correspondances.
        </div>
    </div>

</div>
{% endblock %}